/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * PolicyDetail
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class PolicyDetail {
  @SerializedName("policy_number")
  private String policyNumber = null;

  @SerializedName("external_policy_number")
  private String externalPolicyNumber = null;

  @SerializedName("status")
  private Status status = null;

  @SerializedName("subscription_country")
  private String subscriptionCountry = null;

  @SerializedName("policy_id")
  private String policyId = null;

  @SerializedName("draft_policy_number")
  private String draftPolicyNumber = null;

  @SerializedName("is_tacit_renewal")
  private Boolean isTacitRenewal = null;

  @SerializedName("coverage_start_date")
  private String coverageStartDate = null;

  @SerializedName("product")
  private ProductSummary product = null;

  @SerializedName("price")
  private PolicyPrice price = null;

  @SerializedName("payment")
  private PaymentSummary payment = null;

  @SerializedName("policy_holder")
  private PolicyHolder policyHolder = null;

  @SerializedName("beneficiaries")
  private Model37 beneficiaries = null;

  @SerializedName("attachments")
  private Model39 attachments = null;

  @SerializedName("last_modifications")
  private LastModifications lastModifications = null;

  @SerializedName("travel")
  private Travel travel = null;

  public PolicyDetail policyNumber(String policyNumber) {
    this.policyNumber = policyNumber;
    return this;
  }

   /**
   * Final policy number.
   * @return policyNumber
  **/
  @ApiModelProperty(value = "Final policy number.")
  public String getPolicyNumber() {
    return policyNumber;
  }

  public void setPolicyNumber(String policyNumber) {
    this.policyNumber = policyNumber;
  }

  public PolicyDetail externalPolicyNumber(String externalPolicyNumber) {
    this.externalPolicyNumber = externalPolicyNumber;
    return this;
  }

   /**
   * External policy identifier that can be provided by the partner.
   * @return externalPolicyNumber
  **/
  @ApiModelProperty(value = "External policy identifier that can be provided by the partner.")
  public String getExternalPolicyNumber() {
    return externalPolicyNumber;
  }

  public void setExternalPolicyNumber(String externalPolicyNumber) {
    this.externalPolicyNumber = externalPolicyNumber;
  }

  public PolicyDetail status(Status status) {
    this.status = status;
    return this;
  }

   /**
   * Get status
   * @return status
  **/
  @ApiModelProperty(value = "")
  public Status getStatus() {
    return status;
  }

  public void setStatus(Status status) {
    this.status = status;
  }

  public PolicyDetail subscriptionCountry(String subscriptionCountry) {
    this.subscriptionCountry = subscriptionCountry;
    return this;
  }

   /**
   * Country where the customer subscribes the policy, ISO-3166-1 alpha-2 format (2 letter codes).
   * @return subscriptionCountry
  **/
  @ApiModelProperty(example = "fr", value = "Country where the customer subscribes the policy, ISO-3166-1 alpha-2 format (2 letter codes).")
  public String getSubscriptionCountry() {
    return subscriptionCountry;
  }

  public void setSubscriptionCountry(String subscriptionCountry) {
    this.subscriptionCountry = subscriptionCountry;
  }

  public PolicyDetail policyId(String policyId) {
    this.policyId = policyId;
    return this;
  }

   /**
   * Unique final policy identifier.
   * @return policyId
  **/
  @ApiModelProperty(required = true, value = "Unique final policy identifier.")
  public String getPolicyId() {
    return policyId;
  }

  public void setPolicyId(String policyId) {
    this.policyId = policyId;
  }

  public PolicyDetail draftPolicyNumber(String draftPolicyNumber) {
    this.draftPolicyNumber = draftPolicyNumber;
    return this;
  }

   /**
   * Draft policy number, provided in case if the policy is not confirmed.
   * @return draftPolicyNumber
  **/
  @ApiModelProperty(value = "Draft policy number, provided in case if the policy is not confirmed.")
  public String getDraftPolicyNumber() {
    return draftPolicyNumber;
  }

  public void setDraftPolicyNumber(String draftPolicyNumber) {
    this.draftPolicyNumber = draftPolicyNumber;
  }

  public PolicyDetail isTacitRenewal(Boolean isTacitRenewal) {
    this.isTacitRenewal = isTacitRenewal;
    return this;
  }

   /**
   * Indicates if the policy is automatically renewed.
   * @return isTacitRenewal
  **/
  @ApiModelProperty(example = "true", value = "Indicates if the policy is automatically renewed.")
  public Boolean isIsTacitRenewal() {
    return isTacitRenewal;
  }

  public void setIsTacitRenewal(Boolean isTacitRenewal) {
    this.isTacitRenewal = isTacitRenewal;
  }

  public PolicyDetail coverageStartDate(String coverageStartDate) {
    this.coverageStartDate = coverageStartDate;
    return this;
  }

   /**
   * Start date of policy coverage - ISO 8601 format (YYYY-MM-DD).
   * @return coverageStartDate
  **/
  @ApiModelProperty(example = "2018-01-25", value = "Start date of policy coverage - ISO 8601 format (YYYY-MM-DD).")
  public String getCoverageStartDate() {
    return coverageStartDate;
  }

  public void setCoverageStartDate(String coverageStartDate) {
    this.coverageStartDate = coverageStartDate;
  }

  public PolicyDetail product(ProductSummary product) {
    this.product = product;
    return this;
  }

   /**
   * Get product
   * @return product
  **/
  @ApiModelProperty(value = "")
  public ProductSummary getProduct() {
    return product;
  }

  public void setProduct(ProductSummary product) {
    this.product = product;
  }

  public PolicyDetail price(PolicyPrice price) {
    this.price = price;
    return this;
  }

   /**
   * Get price
   * @return price
  **/
  @ApiModelProperty(value = "")
  public PolicyPrice getPrice() {
    return price;
  }

  public void setPrice(PolicyPrice price) {
    this.price = price;
  }

  public PolicyDetail payment(PaymentSummary payment) {
    this.payment = payment;
    return this;
  }

   /**
   * Get payment
   * @return payment
  **/
  @ApiModelProperty(value = "")
  public PaymentSummary getPayment() {
    return payment;
  }

  public void setPayment(PaymentSummary payment) {
    this.payment = payment;
  }

  public PolicyDetail policyHolder(PolicyHolder policyHolder) {
    this.policyHolder = policyHolder;
    return this;
  }

   /**
   * Get policyHolder
   * @return policyHolder
  **/
  @ApiModelProperty(required = true, value = "")
  public PolicyHolder getPolicyHolder() {
    return policyHolder;
  }

  public void setPolicyHolder(PolicyHolder policyHolder) {
    this.policyHolder = policyHolder;
  }

  public PolicyDetail beneficiaries(Model37 beneficiaries) {
    this.beneficiaries = beneficiaries;
    return this;
  }

   /**
   * Get beneficiaries
   * @return beneficiaries
  **/
  @ApiModelProperty(value = "")
  public Model37 getBeneficiaries() {
    return beneficiaries;
  }

  public void setBeneficiaries(Model37 beneficiaries) {
    this.beneficiaries = beneficiaries;
  }

  public PolicyDetail attachments(Model39 attachments) {
    this.attachments = attachments;
    return this;
  }

   /**
   * Get attachments
   * @return attachments
  **/
  @ApiModelProperty(value = "")
  public Model39 getAttachments() {
    return attachments;
  }

  public void setAttachments(Model39 attachments) {
    this.attachments = attachments;
  }

  public PolicyDetail lastModifications(LastModifications lastModifications) {
    this.lastModifications = lastModifications;
    return this;
  }

   /**
   * Get lastModifications
   * @return lastModifications
  **/
  @ApiModelProperty(value = "")
  public LastModifications getLastModifications() {
    return lastModifications;
  }

  public void setLastModifications(LastModifications lastModifications) {
    this.lastModifications = lastModifications;
  }

  public PolicyDetail travel(Travel travel) {
    this.travel = travel;
    return this;
  }

   /**
   * Get travel
   * @return travel
  **/
  @ApiModelProperty(value = "")
  public Travel getTravel() {
    return travel;
  }

  public void setTravel(Travel travel) {
    this.travel = travel;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PolicyDetail policyDetail = (PolicyDetail) o;
    return Objects.equals(this.policyNumber, policyDetail.policyNumber) &&
        Objects.equals(this.externalPolicyNumber, policyDetail.externalPolicyNumber) &&
        Objects.equals(this.status, policyDetail.status) &&
        Objects.equals(this.subscriptionCountry, policyDetail.subscriptionCountry) &&
        Objects.equals(this.policyId, policyDetail.policyId) &&
        Objects.equals(this.draftPolicyNumber, policyDetail.draftPolicyNumber) &&
        Objects.equals(this.isTacitRenewal, policyDetail.isTacitRenewal) &&
        Objects.equals(this.coverageStartDate, policyDetail.coverageStartDate) &&
        Objects.equals(this.product, policyDetail.product) &&
        Objects.equals(this.price, policyDetail.price) &&
        Objects.equals(this.payment, policyDetail.payment) &&
        Objects.equals(this.policyHolder, policyDetail.policyHolder) &&
        Objects.equals(this.beneficiaries, policyDetail.beneficiaries) &&
        Objects.equals(this.attachments, policyDetail.attachments) &&
        Objects.equals(this.lastModifications, policyDetail.lastModifications) &&
        Objects.equals(this.travel, policyDetail.travel);
  }

  @Override
  public int hashCode() {
    return Objects.hash(policyNumber, externalPolicyNumber, status, subscriptionCountry, policyId, draftPolicyNumber, isTacitRenewal, coverageStartDate, product, price, payment, policyHolder, beneficiaries, attachments, lastModifications, travel);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PolicyDetail {\n");
    
    sb.append("    policyNumber: ").append(toIndentedString(policyNumber)).append("\n");
    sb.append("    externalPolicyNumber: ").append(toIndentedString(externalPolicyNumber)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    subscriptionCountry: ").append(toIndentedString(subscriptionCountry)).append("\n");
    sb.append("    policyId: ").append(toIndentedString(policyId)).append("\n");
    sb.append("    draftPolicyNumber: ").append(toIndentedString(draftPolicyNumber)).append("\n");
    sb.append("    isTacitRenewal: ").append(toIndentedString(isTacitRenewal)).append("\n");
    sb.append("    coverageStartDate: ").append(toIndentedString(coverageStartDate)).append("\n");
    sb.append("    product: ").append(toIndentedString(product)).append("\n");
    sb.append("    price: ").append(toIndentedString(price)).append("\n");
    sb.append("    payment: ").append(toIndentedString(payment)).append("\n");
    sb.append("    policyHolder: ").append(toIndentedString(policyHolder)).append("\n");
    sb.append("    beneficiaries: ").append(toIndentedString(beneficiaries)).append("\n");
    sb.append("    attachments: ").append(toIndentedString(attachments)).append("\n");
    sb.append("    lastModifications: ").append(toIndentedString(lastModifications)).append("\n");
    sb.append("    travel: ").append(toIndentedString(travel)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

